
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <fcntl.h>
#include <sys/ioctl.h>

#include "defines.h"

int main(int ac, char **av)
{

   //int i;
   int fd;
   int pid_to_hook;

   if(ac != 2)
   {
      printf("Usage: set_pid pid\n");
      printf("Set the pid to hook.\n\n");
      exit(0);
   }

   pid_to_hook = atoi(av[1]);

   if(pid_to_hook <= 0)
   {
      fprintf(stderr, "Error, pid must be > 0.\n");
      exit(1);
   }

   //Open the device in order to communicate with the driver
   fd = open(DEVICE_FILE_NAME, O_RDONLY);

   if(fd == -1)
   {
      printf("Error: %s does not exist!\n", DEVICE_FILE_NAME);
      exit(1);
   }

   //Send IOCTLs to the driver to set the pid do hook
   if(ioctl(fd, IOCTL_SET_PID, pid_to_hook))
   {
      fprintf(stderr, "Error setting the pid.\n");
   }
   else
   {
      printf("pid set successfully.\n");
   }

   //Close the device
   close(fd);

}

