
.globl interrupt_handler

//The interrupt handler.
//This function must be naked. Since it's not possible with gcc on x86 platforms, we put it in a separate asm file.
interrupt_handler: 

   //Save registers
   pusha
   pushf
   
   //Call our hook function and  the parameter
   //Since convention call of my_func_handler is fastcall, parameter has to be in %ecx
   mov %esp, %ecx
   call my_func_handler

   //Check the return value
   cmp $1, %eax

   //If 1, throw the exception away
   je  my_exit

   //Otherwise, restore registers
   popf
   popa

   //Jump to the original handler
   jmpl * old_int_handler

my_exit:

   //Restore registers
   popf
   popa

   //Pop interrupt error code
   add $4, %esp

   //Return from interrupt
   iret

